<?php
/**
 * Class Enterprisepayment_ApplicationController
 */
class Enterprisepayment_ApplicationController extends Application_Controller_Default {


	/*change gateway status in editor section*/
	public function changegatewaystatusAction() {
		$gid = $this->getRequest()->getParam("gid");
		$value_id = $this->getRequest()->getParam("value_id");
		try {
			$status = $this->getRequest()->getParam("is_visible");
			$gatewaysmodel = new Enterprisepayment_Model_Enterprisepayment();
			$gatewaydata = $gatewaysmodel->find(array('id' => $gid));
			$payment_code = $gatewaydata->getCode();
			$gateway_model = new Enterprisepayment_Model_Gatewaydetail();
			$gatewaydata = $gateway_model->find(array('gid' => $gid, 'value_id' => $value_id));

			/*check cash payment*/ 
			if($payment_code != 'cash'){
				if (count($gatewaydata->getdata()) > 0) {
					$setStatus = $gateway_model
								->find(array('gid' => $gid,'value_id' => $value_id))
								->setStatus($status)->save();

					$html = array(
						'success' => '1',
						'success_message' => $this->_('Update successfully'),
						'message_timeout' => 2,
						'message_button' => 0,
						'message_loader' => 0,
					);
				} else {
					throw new Exception($this->_('Please enter all credentials after clicking on edit option'));
				}
			}else{
				$detailmodel = new Enterprisepayment_Model_Gatewaydetail();
				$postArray = array();
				$postArray['value_id'] = $value_id;
				$postArray['gid'] = $gid;
				$postArray['payment_mode'] = '';
				$postArray['live_data'] = '';
				$postArray['test_data'] = '';
				$postArray['status'] = $status;
				$gdata = $detailmodel
						->find(array('gid' => $gid, 'value_id' => $value_id))
						->setData($postArray)->save();
				$setStatus = $gateway_model
							->find(array('gid' => $gid))
							->setStatus($status)->save();
				$html = array(
						'success' => '1',
						'success_message' => $this->_('Update successfully'),
						'message_timeout' => 2,
						'message_button' => 0,
						'message_loader' => 0,
					);
			}
			
		} catch (Exception $e) {
			$html = array(
				'error' => 1,
				'message' => $e->getMessage(),
			);
		}
		$this->getLayout()->setHtml(Zend_Json::encode($html));
	}

	/*Load stripe form*/
	public function loadstripeformAction() {

		$pgid = $this->getRequest()->getParam("gid");
		$pvalue_id = $this->getRequest()->getParam("value_id");
		$detailmodel = new Enterprisepayment_Model_Gatewaydetail();
		$gdata = $detailmodel->find(array('gid' => $pgid, 'value_id' => $pvalue_id));

		$testArray = json_decode($gdata->getTestData());
		$liveArray = json_decode($gdata->getLiveData());

		$data = array();
		if ($gdata->getId()) {
			$data['id'] = $gdata->getId();
			$data['value_id'] = $pvalue_id;
			$data['gid'] = $pgid;
			$data['live_publishkey'] = $liveArray->live_publishkey;
			$data['test_publishkey'] = $testArray->test_publishkey;
			$data['live_secrete_key'] = $liveArray->live_secrete_key;
			$data['test_secrete_key'] = $testArray->test_secrete_key;
			$data['status'] = $gdata->getStatus();
			$data['payment_mode'] = $gdata->getPaymentMode();
		} else {
			$data['id'] = null;
			$data['value_id'] = $pvalue_id;
			$data['gid'] = $pgid;
			$data['live_publishkey'] = null;
			$data['test_publishkey'] = null;
			$data['live_secrete_key'] = null;
			$data['test_secrete_key'] = null;
			$data['status'] = null;
			$data['payment_mode'] = null;
		}

		$form = new Enterprisepayment_Form_Stripeform();
		$form->populate($data);
		$form->removeNav("gateway-save-nav");
		$form->addNav("gateway-save-edit-nav", "Save", false);
		$payload = [
			'success' => true,
			'form' => $form->render(),
			'message' => __('Success.'),
			'data' => $gdata->getData(),
		];

		$this->_sendJson($payload);
	}

	/*Save stripe form into db*/
	public function savestripeformAction() {
		$values = $this->getRequest()->getPost();

		try {
			/*live mode payment*/
			if ($values['payment_mode'] == 1) {

				$errors = array();

				if (empty($values['live_publishkey'])) {
					$errors[] = "live_publishkey";
				}
				if (empty($values['live_secrete_key'])) {
					$errors[] = "live_secrete_key";
				}
				

				if (!empty($errors)) {
					$message = array(__("Please enter all stripe credentials after clicking on edit option"));
					foreach ($errors as $error) {
						$message[] = $error;
					}
					$message = join(',', $message);

					throw new Exception($message);
				}
			}

			/*Test payment mode*/
			if ($values['payment_mode'] == 0) {

				$errors = array();

				if (empty($values['test_publishkey'])) {
					$errors[] = "Test Publish key";
				}
				if (empty($values['test_secrete_key'])) {
					$errors[] = "Test Secret key";
				}
				if (!empty($errors)) {
					$message = array(__("Please enter all stripe credentials after clicking on edit option"));
					foreach ($errors as $error) {
						$message[] = $error;
					}
					$message = join(',', $message);

					throw new Exception($message);
				}
			}

			if (!empty($errors)) {
				$message = array(__("Please enter all stripe credentials after clicking on edit option"));
				foreach ($errors as $error) {
					$message[] = $error;
				}
				$message = join(',', $message);

				throw new Exception($message);
			}

			$postArray = [];

			$liveDataArray = array('live_publishkey' => $values['live_publishkey'], 'live_secrete_key' => $values['live_secrete_key']);

			$testDataArray = array('test_publishkey' => $values['test_publishkey'], 'test_secrete_key' => $values['test_secrete_key']);

			$postArray['id'] = $values['id'];
			$postArray['value_id'] = $values['value_id'];
			$postArray['gid'] = $values['gid'];
			$postArray['payment_mode'] = $values['payment_mode'];
			$postArray['live_data'] = json_encode($liveDataArray);
			$postArray['test_data'] = json_encode($testDataArray);
			$postArray['status'] = $values['status'];

			$detailmodel = new Enterprisepayment_Model_Gatewaydetail();
			
			$gdata = $detailmodel
				->find(array('gid' => $values['gid'],'value_id' => $values['value_id']))
				->setData($postArray)
				->save();
				
			$data = array(
				"success" => 1,
				"message" => __("Success"),
			);

		} catch (Exception $e) {
			$data = array(
				"error" => 1,
				"message" => __($e->getMessage()),
			);
		}

		$this->getLayout()->setHtml(Zend_Json::encode($data));
	}

	/*load paypal gateway form*/
	public function loadgatewayformAction() {

		$values = $this->getRequest()->getPost();
		$pgid = $this->getRequest()->getParam("gid");
		$pvalue_id = $this->getRequest()->getParam("value_id");

		$gid = $values['gid'];
		$value_id = $values['value_id'];

		$detailmodel = new Enterprisepayment_Model_Gatewaydetail();
		$gdata = $detailmodel->find(array('gid' => $pgid, 'value_id' => $pvalue_id));

		$testArray = json_decode($gdata->getTestData());
		$liveArray = json_decode($gdata->getLiveData());

		$data = array();
		if ($gdata->getId()) {
			$data['id'] = $gdata->getId();
			$data['value_id'] = $pvalue_id;
			$data['gid'] = $pgid;
			$data['username'] = $liveArray->username;
			$data['sandboxusername'] = $testArray->sandboxusername;
			$data['signature'] = $liveArray->signature;
			$data['sandboxsignature'] = $testArray->sandboxsignature;
			$data['password'] = $liveArray->password;
			$data['sandboxpassword'] = $testArray->sandboxpassword;
			$data['status'] = $gdata->getStatus();
			$data['payment_mode'] = $gdata->getPaymentMode();
		} else {
			$data['id'] = null;
			$data['value_id'] = $pvalue_id;
			$data['gid'] = $pgid;
			$data['username'] = null;
			$data['sandboxusername'] = null;
			$data['signature'] = null;
			$data['sandboxsignature'] = null;
			$data['password'] = null;
			$data['sandboxpassword'] = null;
			$data['status'] = null;
			$data['payment_mode'] = null;
		}

		$form = new Enterprisepayment_Form_Gatewaydetail();
		$form->populate($data);
		$form->removeNav("gateway-save-nav");
		$form->addNav("gateway-save-edit-nav", "Save", false);
		$payload = [
			'success' => true,
			'form' => $form->render(),
			'message' => __('Success'),
			'data' => $gdata->getData(),
		];

		$this->_sendJson($payload);
	}

	/*Save paypal details*/
	public function savepaypaldetailAction() {
		$values = $this->getRequest()->getPost();
		try {

			if ($values['payment_mode'] == 1) {

				$errors = array();

				if (empty($values['username'])) {
					$errors[] = "Username";
				}
				if (empty($values['signature'])) {
					$errors[] = "Signature";
				}
				if (empty($values['password'])) {
					$errors[] = "Password";
				}

				if (!empty($errors)) {
					$message = array(__("Please enter all paypal credentials after clicking on edit option"));
					foreach ($errors as $error) {
						$message[] = $error;
					}
					$message = join(',', $message);

					throw new Exception($message);
				}
			}

			if ($values['payment_mode'] == 0) {

				$errors = array();

				if (empty($values['sandboxusername'])) {
					$errors[] = "Sandbox Username";
				}
				if (empty($values['sandboxsignature'])) {
					$errors[] = "Sandbox Signature";
				}
				if (empty($values['sandboxpassword'])) {
					$errors[] = "Sandbox Password";
				}

				if (!empty($errors)) {
					$message = array(__("Please enter all paypal credentials after clicking on edit option"));
					foreach ($errors as $error) {
						$message[] = $error;
					}
					$message = join(',', $message);

					throw new Exception($message);
				}
			}

			if (!empty($errors)) {
				$message = array(__("Please enter all paypal credentials after clicking on edit option"));
				foreach ($errors as $error) {
					$message[] = $error;
				}
				$message = join(',', $message);

				throw new Exception($message);
			}

			$postArray = array();

			$liveDataArray = array('username' => $values['username'], 'signature' => $values['signature'], 'password' => $values['password']);

			$sandboxDataArray = array('sandboxusername' => $values['sandboxusername'], 'sandboxsignature' => $values['sandboxsignature'], 'sandboxpassword' => $values['sandboxpassword']);

			$postArray['id'] = $values['id'];
			$postArray['value_id'] = $values['value_id'];
			$postArray['gid'] = $values['gid'];
			$postArray['payment_mode'] = $values['payment_mode'];
			$postArray['live_data'] = json_encode($liveDataArray);
			$postArray['test_data'] = json_encode($sandboxDataArray);
			$postArray['status'] = $values['status'];

			$detailmodel = new Enterprisepayment_Model_Gatewaydetail();
			$gdata = $detailmodel->find(array('id' => $values['id']))
				->setData($postArray)->save();

			$data = array(
				"success" => 1,
				"message" => __("Success"),
			);

		} catch (Exception $e) {
			$data = array(
				"error" => 1,
				"message" => __($e->getMessage()),
			);
		}

		$this->getLayout()->setHtml(Zend_Json::encode($data));
	}

	/*Get all modules name from application*/
	public function getpagesAction(){
		$application = $this->getApplication();
        $option_values = $application->getPages(50, true);
        $pages = array();
        foreach ($option_values as $option_value) {  
            if($option_value->getIsActive()){
                 $pages[$option_value->getMobileUri().'index/value_id/'.$option_value->getValueId()] =  $option_value->getTabbarName(); 
             }        
        }       
        $this->_sendJson($pages);
	}

	/*Setting details*/
	public function settingdetailAction(){
		$values = $this->getRequest()->getPost();
		//print_r($values);die;
		 try {
		 	if($values['return_value_id'] == '') {
		 		//$return_value_id = (explode("/",$values['return_url']))['4'];
		 		$return_value_id = (explode("value_id/",$values['return_url']));
		 		$return_value_id = $return_value_id[1];
		 	} else {
		 		$return_value_id = $values['return_value_id'];
		 	}
			$setting_model = new Enterprisepayment_Model_Setting();
			$setting_model
				->find(array('value_id' => $values['value_id']))
				->setData($values)
				->setReturnValueId($return_value_id)
				->save();
			$data = array(
				"success" => 1,
				"message" => __("Success"),
			);
		} catch (Exception $e) {
			$data = array(
				"error" => 1,
				"message" => __($e->getMessage()),
			);
		}
		$this->_sendHtml($data);
	}

	/*Get setting tab data*/
	public function settingdataAction(){
		$values = $this->getRequest()->getPost();
		try {
			$setting_model = new Enterprisepayment_Model_Setting();
		 	$setting_data = $setting_model->find(array('value_id' => $values['value_id']))->getData();
		 	$data = array(
				"success" => 1,
				"message" => __("Success"),
				"data" => $setting_data
			);	
		}catch (Exception $e) {
			$data = array(
				"error" => 1,
				"message" => __($e->getMessage()),
			);
		}
		$this->_sendHtml($data);
	 		
	}

	/*Save bank transfer form details*/
	public function savebanktransferformAction(){
		
		try {
			$values = $this->getRequest()->getPost();
			$value_id = $values['value_id'];
			$gid = $values['gid'];
			unset($values['value_id']);
			unset($values['gid']);
			
			$postArray = array();

			$postArray['value_id'] = $value_id;
			$postArray['gid'] = $gid;
			$postArray['payment_mode'] = '';
			$postArray['live_data'] = json_encode($values);
			$postArray['test_data'] = '';
			$postArray['status'] = '1';
			$detailmodel = new Enterprisepayment_Model_Gatewaydetail();
			if($postArray != null){
				$gdata = $detailmodel->find(array('value_id' => $value_id,'gid' => $gid))
				->setData($postArray)->save();
			}
			$data = array(
				'success' => '1',
					'success_message' => $this->_('Saved successfully'),
					'message_timeout' => 2,
					'message_button' => 0,
					'message_loader' => 0,
			);

		} catch (Exception $e) {
			$data = array(
				"error" => 1,
				"message" => __($e->getMessage()),
			);
		}
		$this->_sendHtml($data);
	}

	/*Edit label fields and save it to db*/
	public function editlabelfieldAction(){
		try {
			$values = $this->getRequest()->getPost();
			$field_name = $values['field_name'];
			$id = $values['id'];
			$detailmodel = new Enterprisepayment_Model_Banksetting();
			if($field_name != null){
				$gdata = $detailmodel->find(array('id' => $id))
							->setFieldName($field_name)
							->save();
			}
				
			$data = array(
				'success' => '1',
				'success_message' => $this->_('Saved successfully'),
				'message_timeout' => 2,
				'message_button' => 0,
				'message_loader' => 0,
			);

		} catch (Exception $e) {
			$data = array(
				"error" => 1,
				"message" => __($e->getMessage()),
			);
		}
		$this->_sendHtml($data);
	}

	/*Add label fields into db*/
	public function addlabelfieldAction(){
		try {
			$values = $this->getRequest()->getPost();
			$field_name = $values['field_name'];
			$detailmodel = new Enterprisepayment_Model_Banksetting();
			if($field_name != null){
				$gdata = $detailmodel
							->setFieldName($field_name)
							->setValueId($values['value_id'])
							->save();
			}
			$getfields = $detailmodel->find(array('field_name' => $field_name));
			$getfieldata = $getfields->getData();	
			$data = array(
				'success' => '1',
				'field_id' => $getfieldata['id'],
				'field_name' => $getfieldata['field_name']
			);

		} catch (Exception $e) {
			$data = array(
				"error" => 1,
				"message" => __($e->getMessage()),
			);
		}
		$this->_sendHtml($data);
	}

	/*Delete fields from db*/
	public function removefieldAction(){
		try {
			$id = $this->getRequest()->getParam('id');
			if(!empty($this->getRequest()->getParam('value_id'))){
				$detailmodel = new Enterprisepayment_Model_Banksetting();

				$detailmodel->find($id)->delete();

				$html = array(
					'success' => '1',
					'message_timeout' => 2,
					'message_button' => 0,
					'message_loader' => 0,
					'field_id' => $id,
				);
			}
		} catch (Exception $e) {
			$html = array(
				"error" => 1,
				"message" => __($e->getMessage()),
			);
		}
		$this->_sendHtml($html);
	}

	/*Load bank transfer form*/
	public function loadbanktransferformAction(){
		$values = $this->getRequest()->getPost();
		try {
			$load_data = new Enterprisepayment_Model_Banksetting();
			$get_bank_fields = $load_data->findAll(array('value_id' => $values['value_id']));
			$get_form_fields = [];
			foreach ($get_bank_fields as $key => $value) {
				$get_form_fields[] = $value->getData();
			}
			$load_data = new Enterprisepayment_Model_Gatewaydetail();
			$get_bank_data = $load_data->find(array('value_id' => $values['value_id'],'gid' => $values['gid']));
			$get_status = $get_bank_data->getStatus();
			$i=0;
			if($get_bank_data->getData()){
				$get_form_data = $get_bank_data->getData();
				$get_form = json_decode($get_form_data['live_data']);
				foreach ($get_form as $key=>$value) {
					$get_form = $value;
					$get_form_fields[$i]['field_data'] = $get_form;
					$i++;
				}
			}
			$data = array(
				"success" => 1,
				"message" => __("Success"),
				"get_bank_fields" => $get_form_fields,
				"status" => $get_status
			);
		}catch (Exception $e) {
			$data = array(
				"error" => 1,
				"message" => __($e->getMessage()),
			);
		}
		$this->_sendHtml($data);
	}
}		