<?php

/**
 * Class Enterprisepayment_Mobile_ViewController
 */


require_once Core_Model_Directory::getBasePathTo("app/local/") . 'modules/Enterprisepayment/controllers/Api/stripe-php/init.php';


class Enterprisepayment_Mobile_ViewController extends Application_Controller_Mobile_Default {

	const SET_EXPRESS_CHECKOUT = 'SetExpressCheckout';
	private $__pay_url = "";
	
	/*Get all payments from db*/
	public function getmethodsAction() {
		if ($this->getRequest()->getRawBody()) {
			try {

				/*get currency name and symbol*/
				$currency_name = Core_Model_Language::getCurrentCurrency()->getShortName();
				$currency = Core_Model_Language::getCurrentCurrency()->getSymbol();

				$gateway = new Enterprisepayment_Model_Gatewaydetail();
				$data = Zend_Json::decode($this->getRequest()->getRawBody());
				$gatewaydata = $gateway->getAllMethods($data['value']);
				$base_url = $this->getRequest()->getBaseUrl();
				$data = array(
					'success'  => '1',
					'methods'  => $gatewaydata,
					'currency' => $currency,
					'basepath' => $this->getRequest()->getBaseUrl()
				);
			} catch (Exception $e) {
				$data = array(
					"error" => 1,
					"message" => __($e->getMessage()),
				);
			}
			$this->_sendHtml($data);
		}
	}

	/*Paypal payment process*/
	public function paypalpaymentAction() {
		if ($this->getRequest()->getRawBody()) {
			try {
				$data = Zend_Json::decode($this->getRequest()->getRawBody());
				$detailmodel = new Enterprisepayment_Model_Gatewaydetail();
				$paypalCredentials = $detailmodel->find(array('gid' => $data['gid'],'value_id' => $data['value_id']));
				if ($paypalCredentials->getData()) {
					$currency = Core_Model_Language::getCurrentCurrency()->getShortName();
					$base_url = $this->getRequest()->getBaseUrl();

					if ($data['is_webview']) {
						$return_url = $base_url . '/var/apps/browser/index-prod.html#' . $data['BASE_PATH'] .'/enterprisepayment/mobile_list/index/value_id/'. $data['value_id'];
						$cancel_url = $base_url . '/var/apps/browser/index-prod.html#' . $data['BASE_PATH'] .'/enterprisepayment/mobile_list/index/value_id/'. $data['value_id'];
					} else {
						$return_url = $base_url . '/var/apps/browser/index-prod.html#' . $data['current_url'] . 'confirm';
						$cancel_url = $base_url . '/var/apps/browser/index-prod.html#' . $data['current_url'] . 'cancel';
					}

					$params = array(
						'RETURNURL' => trim($return_url),
						'CANCELURL' => trim($cancel_url),
						'PAYMENTREQUEST_0_CURRENCYCODE' => $currency,
						'PAYMENTREQUEST_0_AMT' => $data['amount'],
					);

					$paypal_payment_mode = $paypalCredentials->getPaymentMode();
					if ($paypalCredentials->getPaymentMode() == 0) {
						$testCredentials = json_decode($paypalCredentials->getTestData());
						$paypal_api_user = $testCredentials->sandboxusername;
						$paypal_api_user_pwd = $testCredentials->sandboxpassword;
						$paypal_api_user_signature = $testCredentials->sandboxsignature;
					} else {
						$liveCredentials = json_decode($paypalCredentials->getLiveData());
						$paypal_api_user = $liveCredentials->username;
						$paypal_api_user_pwd = $liveCredentials->password;
						$paypal_api_user_signature = $liveCredentials->signature;
					}
					
					$response = $this->request(self::SET_EXPRESS_CHECKOUT, $params, $paypalCredentials->getPaymentMode(), $paypal_api_user, $paypal_api_user_pwd, $paypal_api_user_signature);

					$detailmodel = new Enterprisepayment_Model_Setting();
					$stripeCredentials = $detailmodel->find(array('value_id' => $data['value_id']));
					$return_url = $stripeCredentials->getReturnLink();
					$return_state = $stripeCredentials->getReturnState();
					$return_value_id = $stripeCredentials->getReturnValueId();

					$html = array('success' => 1, 'token_url' => $this->__pay_url . '&webview=1', 'gid' => $paypalCredentials->getGid(),'return_url'=> $return_url,'return_state'=> $return_state,'return_value_id' => $return_value_id);

				} else {
					$html = array('success' => 0, 'message' => __("Don't have Paypal Credential!"));
				}

			} catch (Exception $e) {
				$html = array('success' => 0, 'message' => $e->getMessage());
			}
		} else {
			$html = array('error' => 1, 'message' => __('An error occurred during process. Please try again later.'));
		}

		$this->_sendHtml($html);
	}

	/*Save paypal payment in transaction table*/
	public function transactionAction() {
		if ($this->getRequest()->getRawBody()) {
			try {
				$data = Zend_Json::decode($this->getRequest()->getRawBody());
				$rData = array('token' => $data['token'],'payer' => $data['payer']);
				$jsonRdata = json_encode($rData);
				$application_id = $this->getApplication()->getId();
				$transactionmodel = new Enterprisepayment_Model_Transaction();

				/*Amount with proper format*/
				$payment_format = strlen(substr(strrchr($data['amount'], "."), 1));
				$amount_pay = $data['amount'];
				if($payment_format == 1 ){
					$amount_paid = $amount_pay.'0';
				}else if($payment_format == 0 ){
					$amount_paid = $amount_pay.'.00';
				}else{
					$amount_paid = $amount_pay;
				}
				$transaction_date = date("Y-m-d H:i:s");
				$transaction = $transactionmodel->setValueId($data['value'])
					->setAppId($application_id)
					->setCustomerId($data['customer_id'])
					->setType($data['gid'])
					->setAmount($amount_paid)
					->setResponseData($jsonRdata)
					->setStatus($data['status'])
					->setTransactionDate($transaction_date)
					->save();
				$send_email = $this->sendemail($data['customer_id'],$transaction_date,$amount_paid,$data['token'],'Paypal');	
				$detailmodel = new Enterprisepayment_Model_Setting();
				$papCredentials = $detailmodel->find(array('value_id' => $data['value']));
				$return_url = $papCredentials->getReturnLink();
				$return_state = $papCredentials->getReturnState();
				$return_value_id = $papCredentials->getReturnValueId();

				$html = array('success' => 1, 'return_url' => $return_url, 'return_state' => $return_state, 'return_value_id' => $return_value_id);
			} catch (Exception $e) {
				$html = array('success' => 0, 'message' => $e->getMessage());
			}
		} else {
			$html = array('error' => 1, 'message' => __('An error occurred during process. Please try again later.'));
		}

		$this->_sendHtml($html);
	}

	/*Function for paypal request*/
	public function request($method, $params, $paypal_payment_mode, $paypal_api_user, $paypal_api_user_pwd, $paypal_api_user_signature) {
		$logger = Zend_Registry::get("logger");

		//for paypal in live mode
		if ($paypal_payment_mode == 1) {
			$api_url = "https://api-3t.paypal.com/nvp";
			$paypal_url = "https://www.paypal.com/webscr?cmd=_express-checkout&useraction=commit&token=";
		} else {
			//paypalpay in test mode
			$api_url = "https://api-3t.sandbox.paypal.com/nvp";
			$paypal_url = "https://www.sandbox.paypal.com/webscr?cmd=_express-checkout&useraction=commit&token=";
		}
		$params = array_merge($params, array(
			'METHOD' => $method,
			'VERSION' => '74.0',
			'USER' => $paypal_api_user,
			'PWD' => $paypal_api_user_pwd,
			'SIGNATURE' => $paypal_api_user_signature,
		));

		$orig_params = $params;

		$params = http_build_query($params);
		$curl = curl_init();
		$curlParams = array(
			CURLOPT_URL => $api_url,
			CURLOPT_POST => 1,
			CURLOPT_POSTFIELDS => $params,
			CURLOPT_RETURNTRANSFER => 1,
			CURLOPT_VERBOSE => 1,
			CURLOPT_SSL_VERIFYPEER => false, //si certificat SSL => true
			CURLOPT_SSL_VERIFYHOST => false, //si certificat SSL => 2
		);
		
		curl_setopt_array($curl, $curlParams);
		/** @todo testing in production for integration */
		if (APPLICATION_ENV == "development") {
			curl_setopt($curl, CURLOPT_SSLVERSION, 6);
		}
		$response = curl_exec($curl);
		$responseArray = array();
		parse_str($response, $responseArray);

		if (curl_errno($curl)) {
			$this->_errors = curl_error($curl);
			$this->_params = $params;
			curl_close($curl);
			$logger->log("CURL error n° " . print_r($this->_errors, true) . ' - response: ' . print_r($response, true), Zend_Log::DEBUG);
			return false;
		} else {
			
			if ($responseArray['ACK'] === 'Success') {
				curl_close($curl);
				
				if (!empty($responseArray['TOKEN']) AND $token = $responseArray['TOKEN']) {
					$this->__pay_url = $paypal_url . $responseArray['TOKEN'];
				} else {
					$this->_response = $responseArray;
				}

				return $responseArray;

			} else {
				$this->_errors = $responseArray;
				$this->_params = $params;
				curl_close($curl);
				$logger->log("CURL error: " . print_r($this->_errors, true), Zend_Log::DEBUG);
				return false;
			}
		}
	}

	/*Stripe payment process*/
	public function stripepaymentAction() {
		if ($this->getRequest()->getRawBody()) {
			try {
				$data = Zend_Json::decode($this->getRequest()->getRawBody());
				\Stripe\Stripe::setApiKey($data['secretkey']);
				$stripe_amt = $data['amount']*100;
				$currency = Core_Model_Language::getCurrentCurrency()->getShortName();

				/*Stripe payment charge process*/
				$charge = \Stripe\Charge::create([
					'amount' => $stripe_amt, 
					'currency' => $currency, 
					'source' => $data['token'],
					'description' => $data['order_id']
				]);
				$stripedata = $charge->jsonSerialize();
				$amount_pay = $stripedata['amount']/100;

				/*Amount with proper format*/
				$payment_format = strlen(substr(strrchr($amount_pay, "."), 1));
				if($payment_format == 1 ){
					$amount_paid = $amount_pay.'0';
				}else if($payment_format == 0 ){
					$amount_paid = $amount_pay.'.00';
				}else{
					$amount_paid = $amount_pay;
				}
				$stripe_id = $stripedata['id'];
				$balance_transaction = $stripedata['balance_transaction'];
				$status = $stripedata['status'];
				if($status == 'succeeded'){
					$status_response = 1;
				}else{
					$status_response = 0;
				}
				$sData = array('id' => $stripe_id,'balance_transaction' => $balance_transaction);
				$jsonRdata = json_encode($sData);
				$transactiondetailmodel = new Enterprisepayment_Model_Transaction();
				$application_id = $this->getApplication()->getId();

				/*Save payment detail into db*/
				$transaction = $transactiondetailmodel->setValueId($data['value'])
					->setAppId($application_id)
					->setCustomerId($data['customer_id'])
					->setType($data['gid'])
					->setAmount($amount_paid)
					->setResponseData($jsonRdata)
					->setStatus($status_response)
					->setTransactionDate(date("Y-m-d H:i:s"))
					->save();
				$send_email = $this->sendemail($data['customer_id'],date("Y-m-d H:i:s"),$amount_paid,$stripe_id,'Stripe');
				if($status_response == 1){
					$detailmodel = new Enterprisepayment_Model_Setting();
					$stripeCredentials = $detailmodel->find(array('value_id' => $data['value']));
					$return_url = $stripeCredentials->getReturnLink();
					$return_state = $stripeCredentials->getReturnState();
					$return_value_id = $stripeCredentials->getReturnValueId();
				}
				$html = array(
					'success' => 1, 
					'return_url' => $return_url,
					'transaction_id' => $stripe_id,
					'return_state' => $return_state, 
					'return_value_id' => $return_value_id
				);
			}catch (Exception $e) {
				$html = array('success' => 0, 'message' => $e->getMessage());
			}
			
		}else {
			$html = array('error' => 1, 'message' => __('An error occurred during process. Please try again later.'));
		}
		$this->_sendHtml($html);
	}

	/*Get publishkey for stripe payment*/
	public function getpublishkeyAction(){
		if ($this->getRequest()->getRawBody()) {
			try {
				$data = Zend_Json::decode($this->getRequest()->getRawBody());
				
				$detailmodel = new Enterprisepayment_Model_Gatewaydetail();
				$stripeCredentials = $detailmodel->find(array('gid' => $data['id'],'value_id' => $data['value']));
				if ($stripeCredentials->getData()) {
					$base_url = $this->getRequest()->getBaseUrl();
					$stripe_payment_mode = $stripeCredentials->getPaymentMode();

					/*Test mode payment for stripe get publish and secret key*/
					if ($stripe_payment_mode == 0) {
						$testCredentials = json_decode($stripeCredentials->getTestData());
						$publishkey = $testCredentials->test_publishkey;
						$secretekey = $testCredentials->test_secrete_key;
						
					} else {
						/*Live mode payment in stripe get publish and secret key*/
						$liveCredentials = json_decode($stripeCredentials->getLiveData());
						$publishkey = $liveCredentials->live_publishkey;
						$secretekey = $liveCredentials->live_secrete_key;
					}

					$html = array(
						'success' => 1, 
						'publishkey' => $publishkey,
						'secretekey' => $secretekey
					);	
				} else {
					$html = array('success' => 0, 'message' => __("Don't have stripe Credential!"));
				}
			}catch (Exception $e) {
				$html = array('success' => 0, 'message' => $e->getMessage());
			}
		}
		$this->_sendHtml($html);
	}

	/*Get bank transfer details*/
	public function getbanktransferformAction(){
		if ($this->getRequest()->getRawBody()) {
			try {
				$data = Zend_Json::decode($this->getRequest()->getRawBody());
				$detailmodel = new Enterprisepayment_Model_Gatewaydetail();
				$bank_data = $detailmodel->find(array('gid' => $data['gid'],'value_id' => $data['value_id']));
				if ($bank_data->getData()) {
					$data_response = $bank_data->getData();
					$json_data = json_decode($data_response['live_data'],true);
					unset($json_data['payment-table_length']);
					unset($json_data['return_link']);
					unset($json_data['return_url']);
					unset($json_data['return_state']);
					unset($json_data['transactionTable_length']);
					foreach ($json_data as $key => $value) {
						$bankfieldsmodel = new Enterprisepayment_Model_Banksetting();
						$getfields = $bankfieldsmodel->find(array('id' => $key));
						unset ($json_data[$key]);
						$new_key =  $getfields->getFieldName();
						$json_data[$new_key] = $value;
					}
					$bankfieldsmodel = new Enterprisepayment_Model_Banksetting();
					$getfields = $bankfieldsmodel->find(array('id' => $id));
					$getfieldata = $getfields->getData();
					$base_url = $this->getRequest()->getBaseUrl();
					$html = array(
						'success' => 1, 
						'bank_data' => $json_data,
					);	
				} else {
					$html = array('success' => 0, 'message' => __("Don't have bank transfer Credential!"));
				}
			}catch (Exception $e) {
				$html = array('success' => 0, 'message' => $e->getMessage());
			}
		}
		$this->_sendHtml($html);
	}

	/*Save bank transfer details*/
	public function postbankresponseAction(){
		if ($this->getRequest()->getRawBody()) {

			try {
				$data = Zend_Json::decode($this->getRequest()->getRawBody());
				$token = $this->generateRandomString();
				$response = array('token' => $token, 'type' => 'bank_transfer_response');
				$jsonResponse = json_encode($response);
				$application_id = $this->getApplication()->getId();

				$transactionmodel = new Enterprisepayment_Model_Transaction();
				/*Amount with proper format*/
				$payment_format = strlen(substr(strrchr($data['amount'], "."), 1));
				$amount_pay = $data['amount'];
				if($payment_format == 1 ){
					$amount_paid = $amount_pay.'0';
				}else if($payment_format == 0 ){
					$amount_paid = $amount_pay.'.00';
				}else{
					$amount_paid = $amount_pay;
				}
				$transaction = $transactionmodel->setValueId($data['value_id'])
					->setAppId($application_id)
					->setCustomerId($data['customer_id'])
					->setType($data['gid'])
					->setAmount($amount_paid)
					->setResponseData($jsonResponse)
					->setStatus('2')
					->setTransactionDate(date("Y-m-d H:i:s"))
					->save();
				//$send_email = $this->sendemail($data['customer_id'],date("Y-m-d H:i:s"),$amount_paid,$token,'Bank Transfer');
				$detailmodel = new Enterprisepayment_Model_Setting();
				$bank_response = $detailmodel->find(array('value_id' => $data['value_id']));
				$return_url = $bank_response->getReturnLink();
				$return_state = $bank_response->getReturnState();
				$return_value_id = $bank_response->getReturnValueId();
				$html = array('success' => 1,'return_url' => $return_url,'return_state' => $return_state,'return_value_id' => $return_value_id, 'token' => $token);
			} catch (Exception $e) {
				$html = array('success' => 0, 'message' => $e->getMessage());
			}
		} else {
			$html = array('error' => 1, 'message' => __('An error occurred during process. Please try again later.'));
		}

		$this->_sendHtml($html);
	}

	/*Save cash details*/
	public function postcashresponseAction(){
		if ($this->getRequest()->getRawBody()) {
			try {
				$data = Zend_Json::decode($this->getRequest()->getRawBody());
				$token = $this->generateRandomString();
				$response = array('token' => $token, 'type' => 'cash');
				$jsonResponse = json_encode($response);
				$application_id = $this->getApplication()->getId();
				$transactionmodel = new Enterprisepayment_Model_Transaction();
				/*Amount with proper format*/
				$payment_format = strlen(substr(strrchr($data['amount'], "."), 1));
				$amount_pay = $data['amount'];
				if($payment_format == 1 ){
					$amount_paid = $amount_pay.'0';
				}else if($payment_format == 0 ){
					$amount_paid = $amount_pay.'.00';
				}else{
					$amount_paid = $amount_pay;
				}
				$transaction_date = date("Y-m-d H:i:s");
				$transaction = $transactionmodel->setValueId($data['value_id'])
					->setAppId($application_id)
					->setCustomerId($data['customer_id'])
					->setType($data['gid'])
					->setAmount($amount_paid)
					->setResponseData($jsonResponse)
					->setStatus('2')
					->setTransactionDate($transaction_date)
					->save();
				//$send_email = $this->sendemail($data['customer_id'],$transaction_date,$amount_paid,$token,'cash');
				$detailmodel = new Enterprisepayment_Model_Setting();
				$bank_response = $detailmodel->find(array('value_id' => $data['value_id']));
				$return_url = $bank_response->getReturnLink();
				$return_state = $bank_response->getReturnState();
				$return_value_id = $bank_response->getReturnValueId();
				$html = array('success' => 1,'return_url' => $return_url,'return_state' => $return_state,'return_value_id' => $return_value_id, 'token' => $token);
			}catch (Exception $e) {
				$html = array('success' => 0, 'message' => $e->getMessage());
			}
				
		}else {
			$html = array('error' => 1, 'message' => __('An error occurred during process. Please try again later.'));
		}
		$this->_sendHtml($html);
	}

	/*Get payment module payment value id*/
	public function getpaymentvalueidAction(){
		try {
			$enterprisepaymentModel = new Enterprisepayment_Model_Enterprisepayment;
        	$response  =  $enterprisepaymentModel->getModuleDetailsByCode('code', 'enterprisepayment', $this->getApplication()->getId());
        	$html = $response['value_id'];
		} catch (Exception $e) {
			$html = array('success' => 0, 'message' => $e->getMessage());
		}

		$this->_sendHtml($html);
	}

	/*Generate random strings for token of bank transfer and cash payment*/
	function generateRandomString($length = 20) {
	    $characters = '0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ';
	    $charactersLength = strlen($characters);
	    $randomString = '';
	    for ($i = 0; $i < $length; $i++) {
	        $randomString .= $characters[rand(0, $charactersLength - 1)];
	    }
	    return $randomString;
	}

	function sendemail($customer_id,$date,$amt,$token,$payment_type){

		$customersmodel = new Customer_Model_Customer();
		$customer_getdata = $customersmodel->find(array('customer_id' => $customer_id))->getData();
		$currency_name = Core_Model_Language::getCurrentCurrency()->getShortName();
		$currency = Core_Model_Language::getCurrentCurrency()->getSymbol();
		$config = Zend_Controller_Front::getInstance()->getParam('bootstrap');
		$sender = $config->getOption('sendermail');

		$layout = $this->getLayout()->loadEmail('enterprisepayment', 'enterprisepayment_email');

		$layout->getPartial('content_email')
			->setEmail($customer_getdata['email'])
			->setDate(date($format, $timestamp))
			->setCustomer($customer_getdata['firstname'])
			->setToken($token)
			->setAmount($amt.''.$currency)
			->setPaymentType($payment_type)
			->setDate($date)
			->setApp($this->getApplication()->getName())->setIcon($this->getApplication()->getIcon());

		$content = $layout->render();
		$mail = new Siberian_Mail();
		$mail->_is_default_mailer = false;
		$mail->setBodyHtml($content);
		$mail->setFrom($sender, $this->getApplication()->getName());
		$mail->_sender_name = $this->getApplication()->getName();
		$mail->addTo($customer_getdata['email'],'test');
		$mail->setSubject(__('Your payment details!', $this->getApplication()->getName()));
		$mail->send();
	}
}